import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import cx from 'classnames';
var BASE_CLASS = 'sui-AtomInput-addon';
var CLASS_ADDON_WRAPPER = 'sui-AtomInput-addonWrapper';
var TYPES = {
  LEFT: 'left',
  RIGHT: 'right'
};

var getClassName = function getClassName(_ref) {
  var type = _ref.type;
  return cx(BASE_CLASS, BASE_CLASS + "--" + type);
};

var AddonHoC = function AddonHoC(WrappedInput) {
  var Addon = function Addon(_ref2) {
    var leftAddon = _ref2.leftAddon,
        rightAddon = _ref2.rightAddon,
        props = _objectWithoutPropertiesLoose(_ref2, ["leftAddon", "rightAddon"]);

    return leftAddon || rightAddon ? /*#__PURE__*/React.createElement("div", {
      className: CLASS_ADDON_WRAPPER
    }, leftAddon && /*#__PURE__*/React.createElement("span", {
      className: getClassName({
        type: TYPES.LEFT
      })
    }, leftAddon), /*#__PURE__*/React.createElement(WrappedInput, props), rightAddon && /*#__PURE__*/React.createElement("span", {
      className: getClassName({
        type: TYPES.RIGHT
      })
    }, rightAddon)) : /*#__PURE__*/React.createElement(WrappedInput, props);
  };

  return Addon;
};

export default AddonHoC;