import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import Input, { inputSizes, inputStates } from './Input';
import Password from './Password';
import Mask from './Mask';
var TYPES = {
  DATE: 'date',
  MASK: 'mask',
  NUMBER: 'number',
  PASSWORD: 'password',
  SUI_PASSWORD: 'sui-password',
  TEXT: 'text',
  TEL: 'tel',
  EMAIL: 'email'
};

var AtomInput = function AtomInput(_ref) {
  var type = _ref.type,
      props = _objectWithoutPropertiesLoose(_ref, ["type"]);

  switch (type) {
    case 'sui-password':
      return /*#__PURE__*/React.createElement(Password, props);

    case 'mask':
      return /*#__PURE__*/React.createElement(Mask, props);

    default:
      return /*#__PURE__*/React.createElement(Input, Object.assign({}, props, {
        type: type
      }));
  }
};

AtomInput.displayName = 'AtomInput';
export default AtomInput;
export { inputSizes, inputStates, TYPES as inputTypes };